#include <stdlib.h>
#include <stdio.h>
#include "rpipe.h"

void
cqueue_init(struct cqueue *cq)
{
	cq->head = 0;
	cq->tail = 0;
}

size_t
cqueue_size(struct cqueue *cq)
{
	return (cq->tail - cq->head + cqueue_max(cq)) % cqueue_max(cq);
}

int
cqueue_enqueue(struct cqueue *cq, int c)
{
	cq->buf[cq->tail] = c;
	cq->tail = (cq->tail + 1) % cqueue_max(cq);
	if (cq->tail == cq->head)
		cq->head = (cq->head + 1) % cqueue_max(cq);
	return 0;
}

int
cqueue_dequeue(struct cqueue *cq)
{
	int c;
	
	if (cqueue_size(cq) == 0)
		return -1;
	c = cq->buf[cq->head];
	cq->head = (cq->head + 1) % cqueue_max(cq);
	return c;
}
